/* prefsform.c
   Copyright (C) 1999 Ben Darnell
   This file is a part of ThoughtStream,
   which is distributed under the GNU GPL.
*/
/* preferences:
   0: prefs structure (see thoughtstream.h) [saved]
   1: custom sort info (see mainform.c) [saved]
   2: last db searched (for system find) [unsaved]
*/

#include <Pilot.h>
#include "callback.h"

#include "thoughtstream.h"

prefstruct prefs;

void ReadPrefs()
{
   Word size=sizeof(prefs);
   SWord ver;
   
   ver=PrefGetAppPreferences('ThSt', 0, &prefs, &size, true);
   if (ver<1) {
      prefs.font=stdFont;
      prefs.display_mode=0;
      StrCopy(prefs.home_mind, "");
      prefs.homeID=0;
      StrCopy(prefs.last_mind, "");
      prefs.lastID=0;
   };
}

void WritePrefs()
{
   PrefSetAppPreferences('ThSt', 0, 1, &prefs, sizeof(prefs), true);
}

static void PrefsFormInit()
{
   /* set font size */
   CtlSetValue(GetObjectPtr(PrefsFont0+prefs.font), 1);
}

static void PrefsFormCleanup()
{
   int i;
   
   /* get font size */
   for (i=0; i<3; i++) {
      if (CtlGetValue(GetObjectPtr(PrefsFont0+i)))
	 prefs.font=i;
   };
}

Boolean PrefsFormHandleEvent(EventPtr e)
{
   Boolean handled=false;

   CALLBACK_PROLOGUE;

   switch (e->eType) {
   case frmOpenEvent:
      PrefsFormInit();
      FrmDrawForm(FrmGetActiveForm());
      handled=true;
      break;

   case frmCloseEvent:
      PrefsFormCleanup();
      break;

   case ctlSelectEvent:
      switch (e->data.ctlSelect.controlID) {
      case DoneButton:
	 PrefsFormCleanup();
	 FrmUpdateForm(MainForm, frmRedrawUpdateCode);
	 FrmReturnToForm(0);
	 handled=1;
	 break;
      };
      break;

   default:
      break;
   };
   CALLBACK_EPILOGUE;
   return handled;
}
