/* thoughtstream.h
   Copyright (C) 1999 Ben Darnell
   This file is a part of ThoughtStream,
   which is distributed under the GNU GPL.
*/
#ifndef thoughtstream_h
#define thoughtstream_h

#include "linkaware.h"

#include "thoughtstreamRsc.h"
#include "wrappers.h"
#include "idea.h"

/* constants */
#define SmallIconWidth (15+2)

/* for ItemActivate */
#define ActivateDefault 0
#define ActivateEdit 1

/* for MindrefForm to pass data back to the caller */
#define mindrefDoneEvent firstUserEvent
/* used for dialogs such as BrowseForm
   A return value may be passed in data.generic.data1 */
#define dlgCloseEvent ((unsigned short)firstUserEvent+1)

/* Globals from thoughtstream.c */
extern DmOpenRef IdeaDB;
/*extern DmOpenRef SyncDB;
  extern DmOpenRef MindrefDB;*/

extern ULong CurrentID;
extern Word CurrentIndex;

extern Word ActiveItemIdeaIndex;
extern SWord ActiveItemIndex;

typedef struct {
   DWord creator;
   ULong id;
   Char db_name[32];
} TSLinkType;
typedef TSLinkType* TSLinkPtr;

/* globals from prefs.c */
typedef struct {
   FontID font;
   Word display_mode;
   Char home_mind[32];
   ULong homeID;
   Char last_mind[32];
   ULong lastID;
} prefstruct;
extern prefstruct prefs;

/* global from mindrefform.c */
extern SWord MindrefIndex;

/* Functions from thoughtstream.c */
Boolean EditMenuHandleEvent(Word menuid);
TSLinkPtr TSLinkNew(DmOpenRef db, Word index);
ULong Random32();
Word EventLoop();

/* Functions from idea.c */
Word IdeaNew(DmOpenRef db, CharPtr name);
Word ItemOffset(Ptr pidea, Word index);
Word IdeaLookup(DmOpenRef db, ULong id);
Word IdeaNumItems(Ptr pidea);
void ItemActivate(Word ideaindex, SWord itemindex, Word mode);
Word ItemNew(DmOpenRef db, Word idea_index, Byte item_type);
SWord IdeaFindByName(DmOpenRef db, CharPtr name);
void ItemDelete(DmOpenRef db, Word idea_index, Word item_index);
void IdeaDelete(DmOpenRef db, Word idea_index);
void LMStoreLink(TSLinkPtr linkinfo);
void IdeaSetDirty(DmOpenRef db, Word index);

/* Functions from mainform.c */
void MainFormInit(FormPtr frm);
void MainFormDraw();
Boolean MainFormHandleEvent(EventPtr e);

/* Functions from mindform.c */
Boolean MindFormHandleEvent(EventPtr e);
Boolean MindOpen(CharPtr name);
DmOpenRef MindOpenFromMindref(Word index);
void MindClose();

/* Functions from noteform.c */
Boolean NoteFormHandleEvent(EventPtr e);

/* Functions from linkform.c */
Boolean LinkFormHandleEvent(EventPtr e);
Ptr MindListGetItem(UInt index);
void MindListDrawFunc(UInt index, RectanglePtr bounds, CharPtr* text);

/* Functions from browseform.c */
Boolean BrowseFormHandleEvent(EventPtr e);
Word BrowseForRecord();

/* Functions from urlform.c */
Boolean URLFormHandleEvent(EventPtr e);

/* Functions from searchform.c */
Boolean SearchFormHandleEvent(EventPtr e);

/* Functions from lmform.c */
Boolean LMFormHandleEvent(EventPtr e);
void LMFollowLink();

/* Functions from fieldform.c */
Boolean FieldFormHandleEvent(EventPtr e);


/* Functions from prefsform.c */
Boolean PrefsFormHandleEvent(EventPtr e);
void ReadPrefs();
void WritePrefs();

/* Functions from mindrefform.c */
Boolean MindrefFormHandleEvent(EventPtr e);


#endif /* thoughtstream_h */
